# store heal amount to storage (for storing to scoreboard at x1000 scale)
$data modify storage heal:temp heal_amount set value $(amount)

# store current health and heal amount (x1000) to scoreboard
execute store result score @s heal.internal.health run data get entity @s Health 1000
execute store result score @s heal.internal.amount run data get storage heal:temp heal_amount 1000

# add current health and heal amount
scoreboard players operation @s heal.internal.health += @s heal.internal.amount

# save new health to storage
execute store result storage heal:temp health float 0.001 run scoreboard players get @s heal.internal.health

# set player health
function heal:internal/util/set_player_health with storage heal:temp

# clear storage and scoreboards
data remove storage heal:temp heal_amount
data remove storage heal:temp health
scoreboard players reset @s heal.internal.health
scoreboard players reset @s heal.internal.amount